Loading...
Searching...
No Matches
TrcPktProcEtmV4I Class Reference
OpenCSD Library : Packet Processors.

`#include <trc_pkt_proc_etmv4i.h>`

Inheritance diagram for TrcPktProcEtmV4I:
[legend]
Collaboration diagram for TrcPktProcEtmV4I:
[legend]

## Public Member Functions

| TrcPktProcEtmV4I ()
| TrcPktProcEtmV4I (int instIDNum)
virtual | ~TrcPktProcEtmV4I ()
Public Member Functions inherited from TrcPktProcBase< EtmV4ITrcPacket, ocsd_etmv4_i_pkt_type, EtmV4Config >
| TrcPktProcBase (const char *component_name)
virtual | ~TrcPktProcBase ()
virtual ocsd_datapath_resp_t | TraceDataIn (const ocsd_datapath_op_t op, const ocsd_trc_index_t index, const uint32_t dataBlockSize, const uint8_t *pDataBlock, uint32_t *numBytesProcessed)
componentAttachPt< IPktDataIn< EtmV4ITrcPacket > > * | getPacketOutAttachPt ()
| Attachement point for the protocol packet output.
componentAttachPt< IPktRawDataMon< EtmV4ITrcPacket > > * | getRawPacketMonAttachPt ()
| Attachment point for the protocol packet monitor.
componentAttachPt< ITrcPktIndexer< ocsd_etmv4_i_pkt_type > > * | getTraceIDIndexerAttachPt ()
| Attachment point for a packet indexer.
virtual ocsd_err_t | setProtocolConfig (const EtmV4Config *config)
| < Set the protocol specific configuration for the decoder.
virtual const EtmV4Config * | getProtocolConfig () const
virtual ocsd_err_t | getStatsBlock (ocsd_decode_stats_t **pp_stats)
virtual void | resetStats ()
Public Member Functions inherited from TrcPktProcI
| TrcPktProcI (const char *component_name)
| TrcPktProcI (const char *component_name, int instIDNum)
virtual | ~TrcPktProcI ()
Public Member Functions inherited from TraceComponent
| TraceComponent (const std::string &name)
| TraceComponent (const std::string &name, int instIDNum)
virtual | ~TraceComponent ()
const std::string & | getComponentName () const
void | setComponentName (const std::string &name)
componentAttachPt< ITraceErrorLog > * | getErrorLogAttachPt ()
ocsd_err_t | setComponentOpMode (uint32_t op_flags)
const uint32_t | getComponentOpMode () const
const uint32_t | getSupportedOpModes () const
void | setAssocComponent (TraceComponent *assocComp)
TraceComponent * | getAssocComponent ()
void | LogDefMessage (const std::string &msg)
Public Member Functions inherited from ITrcDataIn
| ITrcDataIn ()
virtual | ~ITrcDataIn ()

## Protected Types

enum | _process_state { PROC_HDR , PROC_DATA , SEND_PKT , SEND_UNSYNCED , PROC_ERR }
typedef enum TrcPktProcEtmV4I::_process_state | process_state

## Protected Member Functions

virtual ocsd_datapath_resp_t | processData (const ocsd_trc_index_t index, const uint32_t dataBlockSize, const uint8_t *pDataBlock, uint32_t *numBytesProcessed)
| Implementation function for the OCSD_OP_DATA operation.
virtual ocsd_datapath_resp_t | onEOT ()
| Implementation function for the OCSD_OP_EOT operation.
virtual ocsd_datapath_resp_t | onReset ()
| Implementation function for the OCSD_OP_RESET operation.
virtual ocsd_datapath_resp_t | onFlush ()
| Implementation function for the OCSD_OP_FLUSH operation.
virtual ocsd_err_t | onProtocolConfig ()
| Called when the configuration object is passed to the decoder.
virtual const bool | isBadPacket () const
| check if the current packet is an error / bad packet
void | InitPacketState ()
void | InitProcessorState ()
Protected Member Functions inherited from TrcPktProcBase< EtmV4ITrcPacket, ocsd_etmv4_i_pkt_type, EtmV4Config >
ocsd_datapath_resp_t | outputDecodedPacket (const ocsd_trc_index_t index_sop, const EtmV4ITrcPacket *pkt)
void | outputRawPacketToMonitor (const ocsd_trc_index_t index_sop, const EtmV4ITrcPacket *pkt, const uint32_t size, const uint8_t *p_data)
void | indexPacket (const ocsd_trc_index_t index_sop, const ocsd_etmv4_i_pkt_type *packet_type)
ocsd_datapath_resp_t | outputOnAllInterfaces (const ocsd_trc_index_t index_sop, const EtmV4ITrcPacket *pkt, const ocsd_etmv4_i_pkt_type *pkt_type, std::vector< uint8_t > &pktdata)
const bool | hasRawMon () const
void | ClearConfigObj ()
const bool | checkInit ()
void | statsAddTotalCount (const uint64_t count)
void | statsAddUnsyncCount (const uint64_t count)
void | statsAddBadSeqCount (const uint32_t count)
void | statsAddBadHdrCount (const uint32_t count)
void | statsInit ()
Protected Member Functions inherited from TraceComponent
void | LogError (const ocsdError &Error)
void | LogMessage (const ocsd_err_severity_t filter_level, const std::string &msg)
const ocsd_err_severity_t | getErrorLogLevel () const
const bool | isLoggingErrorLevel (const ocsd_err_severity_t level) const
void | updateErrorLogLevel ()
void | do_attach_notify (const int num_attached)
void | Init (const std::string &name)

## Protected Attributes

process_state | m_process_state
bool | m_isInit
EtmV4Config | m_config
TraceRawBuffer | m_trcIn
std::vector< uint8_t > | m_currPacketData
int | m_currPktIdx
EtmV4ITrcPacket | m_curr_packet
ocsd_trc_index_t | m_packet_index
ocsd_trc_index_t | m_blockIndex
bool | m_is_sync
| seen first sync packet
bool | m_first_trace_info
| seen first trace info packet after sync
bool | m_sent_notsync_packet
| send one not sync packet if we see any unsynced data on the channel
unsigned | m_dump_unsynced_bytes
| number of unsynced bytes to send
ocsd_trc_index_t | m_update_on_unsync_packet_index
Protected Attributes inherited from TrcPktProcBase< EtmV4ITrcPacket, ocsd_etmv4_i_pkt_type, EtmV4Config >
const EtmV4Config * | m_config
Protected Attributes inherited from TraceComponent
uint32_t | m_op_flags
| current component operational mode flags.
uint32_t | m_supported_op_flags
| supported component operational mode flags - derived class to intialise.

## Detailed Description

Definition at line 51 of file trc_pkt_proc_etmv4i.h.

## Member Typedef Documentation

## process_state

typedef enum TrcPktProcEtmV4I::_process_state TrcPktProcEtmV4I::process_state

protected

## Member Enumeration Documentation

## _process_state

enum TrcPktProcEtmV4I::_process_state

protected

Enumerator
PROC_HDR |
PROC_DATA |
SEND_PKT |
SEND_UNSYNCED |
PROC_ERR |

Definition at line 71 of file trc_pkt_proc_etmv4i.h.

## Constructor & Destructor Documentation

## TrcPktProcEtmV4I() [1/2]

TrcPktProcEtmV4I::TrcPktProcEtmV4I | ( |  | ) |

## TrcPktProcEtmV4I() [2/2]

TrcPktProcEtmV4I::TrcPktProcEtmV4I | ( | int | instIDNum | ) |

## ~TrcPktProcEtmV4I()

virtual TrcPktProcEtmV4I::~TrcPktProcEtmV4I | ( |  | ) |

virtual

## Member Function Documentation

## InitPacketState()

void TrcPktProcEtmV4I::InitPacketState | ( |  | ) |

protected

## InitProcessorState()

void TrcPktProcEtmV4I::InitProcessorState | ( |  | ) |

protected

## onEOT()

virtual ocsd_datapath_resp_t TrcPktProcEtmV4I::onEOT | ( |  | ) |

protected virtual

Implementation function for the OCSD_OP_EOT operation.

Implements TrcPktProcI.

## onFlush()

virtual ocsd_datapath_resp_t TrcPktProcEtmV4I::onFlush | ( |  | ) |

protected virtual

Implementation function for the OCSD_OP_FLUSH operation.

Implements TrcPktProcI.

## onProtocolConfig()

virtual ocsd_err_t TrcPktProcEtmV4I::onProtocolConfig | ( |  | ) |

protected virtual

Called when the configuration object is passed to the decoder.

Implements TrcPktProcI.

## onReset()

virtual ocsd_datapath_resp_t TrcPktProcEtmV4I::onReset | ( |  | ) |

protected virtual

Implementation function for the OCSD_OP_RESET operation.

Implements TrcPktProcI.

## processData()

virtual ocsd_datapath_resp_t TrcPktProcEtmV4I::processData | ( | const ocsd_trc_index_t | index,
|  | const uint32_t | dataBlockSize,
|  | const uint8_t * | pDataBlock,
|  | uint32_t * | numBytesProcessed )

protected virtual

Implementation function for the OCSD_OP_DATA operation.

Implements TrcPktProcI.

## Member Data Documentation

## m_blockIndex

ocsd_trc_index_t TrcPktProcEtmV4I::m_blockIndex

protected

Definition at line 96 of file trc_pkt_proc_etmv4i.h.

## m_config

EtmV4Config TrcPktProcEtmV4I::m_config

protected

Definition at line 88 of file trc_pkt_proc_etmv4i.h.

## m_curr_packet

EtmV4ITrcPacket TrcPktProcEtmV4I::m_curr_packet

protected

Definition at line 94 of file trc_pkt_proc_etmv4i.h.

## m_currPacketData

std::vector<uint8_t> TrcPktProcEtmV4I::m_currPacketData

protected

Definition at line 92 of file trc_pkt_proc_etmv4i.h.

## m_currPktIdx

int TrcPktProcEtmV4I::m_currPktIdx

protected

Definition at line 93 of file trc_pkt_proc_etmv4i.h.

## m_dump_unsynced_bytes

unsigned TrcPktProcEtmV4I::m_dump_unsynced_bytes

protected

number of unsynced bytes to send

Definition at line 102 of file trc_pkt_proc_etmv4i.h.

## m_first_trace_info

bool TrcPktProcEtmV4I::m_first_trace_info

protected

seen first trace info packet after sync

Definition at line 100 of file trc_pkt_proc_etmv4i.h.

## m_is_sync

bool TrcPktProcEtmV4I::m_is_sync

protected

seen first sync packet

Definition at line 99 of file trc_pkt_proc_etmv4i.h.

## m_isInit

bool TrcPktProcEtmV4I::m_isInit

protected

packet processor configuration

Definition at line 85 of file trc_pkt_proc_etmv4i.h.

## m_packet_index

ocsd_trc_index_t TrcPktProcEtmV4I::m_packet_index

protected

Definition at line 95 of file trc_pkt_proc_etmv4i.h.

## m_process_state

process_state TrcPktProcEtmV4I::m_process_state

protected

Definition at line 79 of file trc_pkt_proc_etmv4i.h.

## m_sent_notsync_packet

bool TrcPktProcEtmV4I::m_sent_notsync_packet

protected

send one not sync packet if we see any unsynced data on the channel

Definition at line 101 of file trc_pkt_proc_etmv4i.h.

## m_trcIn

TraceRawBuffer TrcPktProcEtmV4I::m_trcIn

protected

packet data

Definition at line 91 of file trc_pkt_proc_etmv4i.h.

## m_update_on_unsync_packet_index

ocsd_trc_index_t TrcPktProcEtmV4I::m_update_on_unsync_packet_index

protected

Definition at line 103 of file trc_pkt_proc_etmv4i.h.

The documentation for this class was generated from the following file:

- /build/libopencsd-wPklVS/libopencsd-1.5.5/decoder/include/opencsd/etmv4/trc_pkt_proc_etmv4i.h